; #########################################################################

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive

      include Menu.inc        ; local includes for this file

.code

; #########################################################################

start:

    ; ------------------
    ; set global values
    ; ------------------
      mov hInstance, $invoke (GetModuleHandle, NULL)      
      mov CommandLine, $invoke (GetCommandLine) 
      mov hIcon, $invoke (LoadIcon,hInstance,500)	; icon ID
      mov hCursor, $invoke (LoadCursor,NULL,IDC_ARROW)
      mov sWid, $invoke (GetSystemMetrics,SM_CXSCREEN)
      mov sHgt, $invoke (GetSystemMetrics,SM_CYSCREEN)

      call Main

      invoke ExitProcess,eax

; #########################################################################

Main proc

    LOCAL Wwd:DWORD,Wht:DWORD,Wtx:DWORD,Wty:DWORD

    STRING szClassName,"StyleXP"

  ; --------------------------------------------
  ; register class name for CreateWindowEx call
  ; --------------------------------------------
    invoke RegisterWinClass,ADDR WndProc,ADDR szClassName,
                       hIcon,hCursor,COLOR_BTNFACE+1

  ; -------------------------------------------------
  ; macro to autoscale window co-ordinates to screen
  ; percentages and centre window at those sizes.
  ; -------------------------------------------------
    AutoScale 75, 70
  ; -------------------------------------------------
    invoke CreateWindowEx,WS_EX_CLIENTEDGE,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPEDWINDOW,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInstance,NULL
    mov hWnd,eax

  ; ---------------------------
  ; macros for unchanging code
  ; ---------------------------
    DisplayWindow hWnd,SW_SHOWNORMAL

    call MsgLoop
    ret

Main endp

; #########################################################################

RegisterWinClass proc lpWndProc:DWORD, lpClassName:DWORD,
                      Icon:DWORD, Cursor:DWORD, bColor:DWORD

    LOCAL wc:WNDCLASSEX

    mov wc.cbSize,         sizeof WNDCLASSEX
    mov wc.style,          CS_BYTEALIGNCLIENT or \
                           CS_BYTEALIGNWINDOW
    m2m wc.lpfnWndProc,    lpWndProc
    mov wc.cbClsExtra,     NULL
    mov wc.cbWndExtra,     NULL
    m2m wc.hInstance,      hInstance
    m2m wc.hbrBackground,  bColor
    mov wc.lpszMenuName,   NULL
    m2m wc.lpszClassName,  lpClassName
    m2m wc.hIcon,          Icon
    m2m wc.hCursor,        Cursor
    m2m wc.hIconSm,        Icon

    invoke RegisterClassEx, ADDR wc

    ret

RegisterWinClass endp

; ########################################################################

MsgLoop proc

  ; ------------------------------------------
  ; The following 4 equates are available for
  ; processing messages directly in the loop.
  ; m_hWnd - m_Msg - m_wParam - m_lParam
  ; ------------------------------------------

    LOCAL msg:MSG

    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0
      cmp eax, 0
      je ExitLoop
      invoke TranslateMessage, ADDR msg
      invoke DispatchMessage,  ADDR msg
      jmp StartLoop
    ExitLoop:

    mov eax, msg.wParam
    ret

MsgLoop endp

; #########################################################################

WndProc proc hWin   :DWORD, uMsg   :DWORD, wParam :DWORD, lParam :DWORD

    LOCAL var    :DWORD
    LOCAL caW    :DWORD
    LOCAL caH    :DWORD
    LOCAL Rct    :RECT
    LOCAL buffer1[128]:BYTE  ; these are two spare buffers
    LOCAL buffer2[128]:BYTE  ; for text manipulation etc..

    LOCAL hBmpImgList :HBITMAP
    LOCAL imageinfo :IMAGEINFO
    .if uMsg == WM_COMMAND
    ;======== menu commands ========


        .if wParam == ID_FILE_NEW
        
             invoke MessageBox,hWin,SADD("ID_FILE_NEW"),ADDR szNew,MB_OK
             
        .elseif wParam == ID_FILE_OPEN
             invoke MessageBox,hWin,SADD("ID_FILE_OPEN"),ADDR szOpen,MB_OK
             
        .elseif wParam == ID_FILE_SAVE
             invoke MessageBox,hWin,SADD("ID_FILE_SAVE"),ADDR szSave,MB_OK
             
        .elseif wParam == ID_FILE_SAVE_AS
             invoke MessageBox,hWin,SADD("ID_FILE_SAVE_AS"),ADDR szSaveAs,MB_OK
                                     
        .elseif wParam == ID_FILE_PRINT
             invoke MessageBox,hWin,SADD("ID_FILE_PRINT"),ADDR szPrint,MB_OK
             
        .elseif wParam == ID_FILE_PRINT_PREVIEW
             invoke MessageBox,hWin,SADD("ID_FILE_PRINT_PREVIEW"),ADDR szPrintPreview,MB_OK
             
        .elseif wParam == ID_APP_EXIT
        
             invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL

        .elseif wParam == ID_EDIT_UNDO
        
             invoke MessageBox,hWin,SADD("ID_EDIT_UNDO"),ADDR szUndo,MB_OK
             
        .elseif wParam == ID_EDIT_CUT
        
             invoke MessageBox,hWin,SADD("ID_EDIT_CUT"),ADDR szCut,MB_OK
             
        .elseif wParam == ID_EDIT_COPY
        
             invoke MessageBox,hWin,SADD("ID_EDIT_COPY"),ADDR szCopy,MB_OK
             
        .elseif wParam == ID_EDIT_PASTE
        
             invoke MessageBox,hWin,SADD("ID_EDIT_PASTE"),ADDR szPaste,MB_OK
             
        .elseif wParam == ID_EDIT_DELETE
        
             invoke MessageBox,hWin,SADD("DeleteItemSelf"),SADD("Delete"),MB_OK
             METHOD hObjectMenu, TMenu, DeleteItemMenu, wParam           
             
        .elseif wParam == ID_VIEW_STANDARD
        
             invoke MessageBox,hWin,SADD("ID_VIEW_STANDARD"),ADDR szStandard,MB_OK

             METHOD hObjectMenu, TMenu, SetItemChecked, hMenuPopup5, ID_VIEW_STANDARD, REVERSE
                         
        .elseif wParam == ID_VIEW_CUSTOMIZE
        
             invoke MessageBox,hWin,SADD("ID_VIEW_CUSTOMIZE"),ADDR szCustomize,MB_OK
             
        .elseif wParam == ID_VIEW_STATUSBAR
        
             invoke MessageBox,hWin,SADD("ID_VIEW_STATUSBAR"),ADDR szSatatusBar,MB_OK
             
        .elseif wParam == ID_VIEW_TOOLBARS
        
             invoke MessageBox,hWin,SADD("ID_VIEW_TOOLBARS"),ADDR szToolbars,MB_OK                                                                                   

        .elseif wParam == ID_APP_ABOUT

             ShellAboutBox hWin,hIcon,\
                "About Prostart 3 Template#Windows Application",\
                "Prostart 3 Template",13,10,"Copyright  MASM32 2001"
        .endif
    ;====== end menu commands ======

    .elseif uMsg == WM_CREATE

;   
        mov hImageList, $invoke (ImageList_Create, 16, 16, ILC_COLOR or ILC_MASK, 20,0)
        mov hBmpImgList, $invoke (LoadBitmap, hInstance, ID_BMP1)
        invoke ImageList_AddMasked, hImageList, hBmpImgList, Red
        invoke DeleteObject, hBmpImgList
        
; Create Menu
    
     mov hObjectMenu, $NEW( TMenu,hWin ) ; New object menu
 
; Popup 1
     
     mov hMenuPopup1, $EAX(hObjectMenu, TMenu, CreateMenuPopup) ; Create popup menu
     mov mpi1.wID, ID_POPUP1
     mov mpi1.lpString, OFFSET szPopup1
     mov mpi1.hIcon, NULL
     mov mpi1.len, $invoke (lnstr, ADDR szPopup1)
     mov mpi1.dwStyle, MN_POPUP
     METHOD hObjectMenu, TMenu, InsertMenuPopup, hMenuPopup1, NULL, ADDR mpi1 ; Append popup
;    METHOD hObjectMenu, TMenu, SetItemGrayed, ID_POPUP1, DISABLED
     mov mi1.wID, ID_FILE_NEW
     mov mi1.lpString, OFFSET szNew
     mov mi1.hIcon, $invoke (ImageList_GetIcon, hImageList, 0, ILD_NORMAL)
     mov mi1.len, $invoke (lnstr, ADDR szNew)
     mov mi1.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi1 ; Append item "New"
     mov mi2.wID, ID_FILE_OPEN
     mov mi2.lpString, OFFSET szOpen
     mov mi2.hIcon, $invoke (ImageList_GetIcon, hImageList, 1, ILD_NORMAL)
     mov mi2.len, $invoke (lnstr, ADDR szOpen)
     mov mi2.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi2 ; Append item "Open"
     mov mi3.wID, ID_FILE_SAVE
     mov mi3.lpString, OFFSET szSave
     mov mi3.hIcon, $invoke (ImageList_GetIcon, hImageList, 2, ILD_NORMAL)
     mov mi3.len, $invoke (lnstr, ADDR szSave)
     mov mi3.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi3 ; Append item "Save"
     mov mi4.wID, ID_FILE_SAVE_AS
     mov mi4.lpString, OFFSET szSaveAs
     mov mi4.hIcon, NULL
     mov mi4.len, $invoke (lnstr, ADDR szSaveAs)
     mov mi4.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi4 ; Append item "Save As"

     mov mi19.wID, ID_FILE_SEP1
     mov mi19.dwStyle, MN_SEPARATOR
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi19 ; Append SEPARATOR
     
     mov mi5.wID, ID_FILE_PRINT
     mov mi5.lpString, OFFSET szPrint
     mov mi5.hIcon, $invoke (ImageList_GetIcon, hImageList, 8, ILD_NORMAL)
     mov mi5.len, $invoke (lnstr, ADDR szPrint)
     mov mi5.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi5 ; Append item "Print"
     mov mi6.wID, ID_FILE_PRINT_PREVIEW
     mov mi6.lpString, OFFSET szPrintPreview
     mov mi6.hIcon, NULL
     mov mi6.len, $invoke (lnstr, ADDR szPrintPreview)
     mov mi6.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi6 ; Append item "Print Preview"

     mov mi20.wID, ID_FILE_SEP2
     mov mi20.dwStyle, MN_SEPARATOR  
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi20 ; Append SEPARATOR
     
     mov mi7.wID, ID_APP_EXIT
     mov mi7.lpString, OFFSET szExit
     mov mi7.hIcon, NULL
     mov mi7.len, $invoke (lnstr, ADDR szExit)
     mov mi7.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup1, NULL, OFFSET mi7 ; Append item "Exit"

; Popup 2

     mov hMenuPopup2, $EAX(hObjectMenu, TMenu, CreateMenuPopup) ; Create popup menu
     mov mpi2.wID, ID_POPUP2
     mov mpi2.lpString, OFFSET szPopup2
     mov mpi2.hIcon, NULL
     mov mpi2.len, $invoke (lnstr, ADDR szPopup2)
     mov mpi2.dwStyle, MN_POPUP
     METHOD hObjectMenu, TMenu, InsertMenuPopup, hMenuPopup2, NULL, ADDR mpi2 ; Append popup item
     mov mi10.wID, ID_EDIT_UNDO
     mov mi10.lpString, OFFSET szUndo
     mov mi10.hIcon, $invoke (ImageList_GetIcon, hImageList, 11, ILD_NORMAL)
     mov mi10.len, $invoke (lnstr, ADDR szUndo)
     mov mi10.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi10 ; Append item     
     METHOD hObjectMenu, TMenu, SetItemGrayed, hMenuPopup2, ID_EDIT_UNDO, DISABLED  ; ENABLED
     
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi19 ; Append SEPARATOR
     
     mov mi11.wID, ID_EDIT_CUT
     mov mi11.lpString, OFFSET szCut
     mov mi11.hIcon, $invoke (ImageList_GetIcon, hImageList, 3, ILD_NORMAL)
     mov mi11.len, $invoke (lnstr, ADDR szCut)
     mov mi11.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi11 ; Append item
     mov mi12.wID, ID_EDIT_COPY
     mov mi12.lpString, OFFSET szCopy
     mov mi12.hIcon, $invoke (ImageList_GetIcon, hImageList, 4, ILD_NORMAL)
     mov mi12.len, $invoke (lnstr, ADDR szCopy)
     mov mi12.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi12  ; Append item
     mov mi13.wID, ID_EDIT_PASTE
     mov mi13.lpString, OFFSET szPaste
     mov mi13.hIcon, $invoke (ImageList_GetIcon, hImageList, 5, ILD_NORMAL)
     mov mi13.len, $invoke (lnstr, ADDR szPaste)
     mov mi13.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi13 ; Append item
     mov mi21.wID, ID_EDIT_DELETE
     mov mi21.lpString, OFFSET szDeletePaste
     mov mi21.len, $invoke (lnstr, ADDR szDeletePaste)
     mov mi21.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup2, NULL, OFFSET mi21 ; Append item


; Popup 3

     mov hMenuPopup3, $EAX(hObjectMenu, TMenu, CreateMenuPopup) ; Create popup menu
     mov mpi3.wID, ID_POPUP3
     mov mpi3.lpString, OFFSET szPopup3
     mov mpi3.hIcon, NULL
     mov mpi3.len, $invoke (lnstr, ADDR szPopup3)
     mov mpi3.dwStyle, MN_POPUP
     METHOD hObjectMenu, TMenu, InsertMenuPopup, hMenuPopup3, NULL, ADDR mpi3 ; Append popup item
     
;  SUBMENU   
     mov hMenuPopup5, $EAX(hObjectMenu, TMenu, CreateMenuPopup) ; Create popup menu
     
;  SUBMENU ITEMAMI   
     
     mov mi14.wID, ID_VIEW_CUSTOMIZE
     mov mi14.lpString, OFFSET szCustomize
     mov mi14.hIcon, $invoke (ImageList_GetIcon, hImageList, 6, ILD_NORMAL)
     mov mi14.len, $invoke (lnstr, ADDR szCustomize)
     mov mi14.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup5, NULL, OFFSET mi14  ; Append item
     mov mi15.wID, ID_VIEW_STANDARD
     mov mi15.lpString, OFFSET szStandard
     mov mi15.hIcon, NULL
     mov mi15.len, $invoke (lnstr, ADDR szStandard)
     mov mi15.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup5, NULL, OFFSET mi15 ; Append item
     METHOD hObjectMenu, TMenu, SetItemChecked, hMenuPopup5, ID_VIEW_STANDARD, CHECKED   
     
;  SUBMENU
     mov mi16.wID, ID_VIEW_TOOLBARS
     mov mi16.lpString, OFFSET szToolbars
     mov mi16.hIcon, NULL
     mov mi16.len, $invoke (lnstr, ADDR szToolbars)
     mov mi16.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertSubMenuItem, hMenuPopup3, hMenuPopup5, NULL, ADDR mi16 ; Append popup item

     mov mi17.wID, ID_VIEW_STATUSBAR
     mov mi17.lpString, OFFSET szSatatusBar
     mov mi17.hIcon, NULL
     mov mi17.len, $invoke (lnstr, ADDR szSatatusBar)
     mov mi17.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup3, NULL, OFFSET mi17 ; Append item
     METHOD hObjectMenu, TMenu, SetItemChecked, hMenuPopup3, ID_VIEW_STATUSBAR, CHECKED
     METHOD hObjectMenu, TMenu, SetItemGrayed,hMenuPopup3, ID_VIEW_STATUSBAR, DISABLED

; Popup 4

     mov hMenuPopup4, $EAX(hObjectMenu, TMenu, CreateMenuPopup) ; Create popup menu
     mov mpi4.wID, ID_POPUP4
     mov mpi4.lpString, OFFSET szPopup4
     mov mpi4.hIcon, NULL
     mov mpi4.len, $invoke (lnstr, ADDR szPopup4)
     mov mpi4.dwStyle, MN_POPUP
     METHOD hObjectMenu, TMenu, InsertMenuPopup, hMenuPopup4, NULL, ADDR mpi4 ; Append popup item
     mov mi18.wID, ID_APP_ABOUT
     mov mi18.lpString, OFFSET szAbout
     mov mi18.hIcon, $invoke (ImageList_GetIcon, hImageList, 7, ILD_NORMAL)
     mov mi18.len, $invoke (lnstr, ADDR szAbout)
     mov mi18.dwStyle, MN_ITEM
     METHOD hObjectMenu, TMenu, InsertMenuItem, hMenuPopup4, NULL, OFFSET mi18 ; Append item

    .elseif uMsg == WM_MEASUREITEM

     .if !wParam    ; MENU? (wParam == 0 - only menu)           
        METHOD hObjectMenu, TMenu, MeasureItem, lParam
     .endif
;
    .elseif uMsg == WM_DRAWITEM

     .if !wParam    ; MENU? (wParam == 0 - only menu)   
        METHOD hObjectMenu, TMenu, DrawItem, lParam
     .endif

    .elseif uMsg == WM_CONTEXTMENU
        LOWORD lParam
        HIWORD lParam
        invoke TrackPopupMenu, hMenuPopup2, NULL, eax, ebx, NULL, hWin, NULL
    
    .elseif uMsg == WM_SIZE

    .elseif uMsg == WM_CLOSE

    .elseif uMsg == WM_DESTROY
        invoke ImageList_Destroy, hImageList
        DESTROY hObjectMenu
        invoke PostQuitMessage,NULL
        return 0

    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam

    ret

WndProc endp

; ########################################################################

TopXY proc wDim:DWORD, sDim:DWORD

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp

; ########################################################################

end start
