IFNDEF _TMenu_
_TMenu_ equ 1

IC_CENTER   equ 1
IC_LEFTUP   equ 2
IC_LEFT     equ 3
IC_RIGHT    equ 4
IC_UP       equ 5
IC_DOWN     equ 6
IC_RIGHTUP  equ 7
IC_GRAY     equ 10
STYLE_XP    equ 1
TXT_GRAY    equ 1

WidthGray       equ 24
SIZEOFMENUITEM  equ sizeof (MENUITEM)
MN_POPUP        equ 1h
MN_ITEM         equ 2h
MN_SEPARATOR    equ 3h
ENABLED         equ 0
DISABLED        equ 1
CHECKED         equ 0
UNCHECKED       equ 1
REVERSE         equ 2

; --=====================================================================================--
; #CLASS:    TMenu 
; #VERSION:  1.0
; --=====================================================================================--
;
; #AUTHOR:    (Chib777)
; #DATE:   January. 1, 2004
;
; #DESCRIPTION:         ..
;
;
; --=====================================================================================--
; CLASS METHOD PROTOS
; --=====================================================================================--
   TMenu_Init    PROTO  :DWORD, :DWORD

; --=====================================================================================--
; FUNCTION POINTER PROTOS
; --=====================================================================================--
   TMen_destructorPto    TYPEDEF  PROTO  :DWORD 
   TMen_InsertMenuPopupPto    TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD
   TMen_CreateMenuPopupPto    TYPEDEF  PROTO  :DWORD
   TMen_InsertMenuItemPto       TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD
   TMen_DrawItemPto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_MeasureItemPto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_OdaDrawentireXPPto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_OdaFocusPto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_OdaSelectXPPto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_DrawIconPto       TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
   TMen_DrawTextPto       TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
   TMen_SetMenuStylePto       TYPEDEF  PROTO  :DWORD, :DWORD
   TMen_InsertSubMenuItemPto       TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
   TMen_SetItemGrayedPto      TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD
   TMen_SetItemCheckedPto      TYPEDEF  PROTO  :DWORD, :DWORD, :DWORD, :DWORD
   TMen_DeleteItemMenuPto      TYPEDEF  PROTO  :DWORD, :DWORD
      
; --=====================================================================================--
; CLASS STRUCTURE
; --=====================================================================================--
   CLASS TMenu, TMen
      CMETHOD destructor        ; MUST BE THE FIRST, OR OBJECTS.INC WILL FAIL
      CMETHOD InsertMenuPopup   ;      .
      CMETHOD CreateMenuPopup   ;   .
      CMETHOD InsertMenuItem    ;       .
      CMETHOD DrawItem          ;   WM_DRAWITEM
      CMETHOD MeasureItem       ;   WM_MEASUREITEM
      CMETHOD OdaDrawentireXP   ;   WM_DRAWITEM -> ODA_DRAWENTIRE
      CMETHOD OdaFocus          ;   WM_DRAWITEM -> ODA_FOCUS
      CMETHOD OdaSelectXP       ;   WM_DRAWITEM -> ODA_SELECT
      CMETHOD DrawIcon          ;     .
      CMETHOD DrawText          ;     .
      CMETHOD SetMenuStyle      ;     .
      CMETHOD InsertSubMenuItem ;         .
      CMETHOD SetItemGrayed     ;        ,  .
      CMETHOD SetItemChecked    ;      .
      CMETHOD DeleteItemMenu    ;     .                                     
      hMenu HMENU ?             ;   .
      hWindow HANDLE ?          ;     .
      hBrushBlue HBRUSH ?       ;    ,   .
      hPenBlue HPEN ?           ;    ,  .
      hBrushWhite HBRUSH ?      ;    ,    .
      hPenWhite HPEN ?          ;    ,   .
      hBrushGray HBRUSH ?       ;       .
      hBrushLightGray HBRUSH ?  ;       
      hPenGray HPEN ?           ;        CheckItema.
      hBrushShade HBRUSH ?      ;      .
      hBrushCheckDisabled HBRUSH ?  ;    CheckItema.
      hBrushCheckUnSelect HBRUSH ?  ;   CheckItema   .
      hPenFrameCheck HPEN ?         ;     CheckItema.
      hBrushCheckSelect HBRUSH ?    ;   CheckItema   .
      hGlyphFont HFONT ?            ;     CheckItema.
      StyleMenu dd ?                ;  .
   TMenu ENDS

.data

   BEGIN_INIT 
      dd offset TMen_destructor_Funct
      dd offset TMen_InsertMenuPopup_Funct
      dd offset TMen_CreateMenuPopup_Funct
      dd offset TMen_InsertMenuItem_Funct
      dd offset TMen_DrawItem_Funct
      dd offset TMen_MeasureItem_Funct
      dd offset TMen_OdaDrawentireXP_Funct
      dd offset TMen_OdaFocus_Funct
      dd offset TMen_OdaSelectXP_Funct
      dd offset TMen_DrawIcon_Funct
      dd offset TMen_DrawText_Funct
      dd offset TMen_SetMenuStyle_Funct
      dd offset TMen_InsertSubMenuItem_Funct
      dd offset TMen_SetItemGrayed_Funct
      dd offset TMen_SetItemChecked_Funct
      dd offset TMen_DeleteItemMenu_Funct                               
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
      dd NULL
   END_INIT

      GlyphArray    db 62h, 0
      szGlyphFont   db "Marlett",0

.code
; --=====================================================================================--
; #METHOD:      CONSTRUCTOR (hWin:DWORD) 
;
; #PARAM:       hWin         ..
;
; #RETURN:         (    )..
; --=====================================================================================--
TMenu_Init  PROC uses edi lpTHIS:DWORD, hWin:DWORD
   SET_CLASS TMenu
   SetObject edi, TMenu

    m2m [edi].hWindow, hWin 
    mov [edi].hMenu, $invoke (CreateMenu)
    invoke SetMenu,[edi].hWindow,[edi].hMenu
    
    RGB 182, 189, 210   
    mov [edi].hBrushBlue, $invoke (CreateSolidBrush, eax)   
    
    RGB 10, 36, 106 
    mov [edi].hPenBlue, $invoke (CreatePen,PS_SOLID,1,eax)
    
    RGB 219, 216, 209      ;     
    mov [edi].hBrushGray, $invoke (CreateSolidBrush, eax)
      
    RGB 229, 226, 221      ;       ,   
    mov [edi].hBrushLightGray, $invoke (CreateSolidBrush, eax)  
    
    RGB 166, 166, 166      ;  
    mov [edi].hPenGray, $invoke (CreatePen,PS_SOLID,1,eax)
    
    RGB 249, 248, 247      ;       ,   
    mov [edi].hBrushWhite, $invoke (CreateSolidBrush, eax)
                           ; ^ 
    RGB 249, 248, 247      ; |_     () 
    mov [edi].hPenWhite, $invoke (CreatePen,PS_SOLID,1,eax) 
    
    RGB 100, 97, 92        ;    
    mov [edi].hBrushShade, $invoke (CreateSolidBrush, eax)
    
    RGB 190, 187, 182
    mov [edi].hBrushCheckDisabled, $invoke (CreateSolidBrush, eax)  
    RGB 212, 213, 216
    mov [edi].hBrushCheckUnSelect, $invoke (CreateSolidBrush, eax)  
    RGB 133, 146, 181
    mov [edi].hBrushCheckSelect, $invoke (CreateSolidBrush, eax)    
    RGB 10, 36, 106
    mov [edi].hPenFrameCheck, $invoke (CreatePen,PS_SOLID,1,eax)    
    
    invoke CreateFont, 17, 14, 0, 0, FW_NORMAL, 0, 0, 0, DEFAULT_CHARSET, 0, 0, 0, 0, ADDR szGlyphFont
    mov [edi].hGlyphFont, eax
            
;     XP    
    METHOD edi, TMenu, SetMenuStyle, STYLE_XP
    
   ReleaseObject edi
   ret
TMenu_Init ENDP

; --=====================================================================================--
; #METHOD:      destructor (NONE)

; #DESCRIPTION:   ,     ,
;                     ..
;
; #RETURN:      Nothing..
; --=====================================================================================--
TMen_destructor_Funct  PROC uses edi lpTHIS:DWORD 
   SetObject edi, TMenu

    invoke DeleteObject,[edi].hBrushBlue
    invoke DeleteObject,[edi].hPenBlue
    invoke DeleteObject,[edi].hBrushGray
    invoke DeleteObject,[edi].hBrushLightGray
    invoke DeleteObject,[edi].hPenGray
    invoke DeleteObject,[edi].hBrushWhite
    invoke DeleteObject,[edi].hPenWhite
    invoke DeleteObject,[edi].hBrushShade
    invoke DeleteObject,[edi].hBrushCheckDisabled
    invoke DeleteObject,[edi].hBrushCheckUnSelect
    invoke DeleteObject,[edi].hBrushCheckSelect
    invoke DeleteObject,[edi].hPenFrameCheck
    invoke DeleteObject,[edi].hGlyphFont    

   ReleaseObject edi
   ret
TMen_destructor_Funct  ENDP

; --=====================================================================================--
; #METHOD:      InsertMenuPopup (:DWORD, :DWORD)
;
; #DESCRIPTION:           ..
;
; #PARAM:       hSubMenu  ..
; #PARAM:       uItem          
;                        ..
; #PARAM:       lpmi      MENUITEM,     ..
;
; #RETURN:      TRUE -     ,     FALSE..;               
; --=====================================================================================--
TMen_InsertMenuPopup_Funct  PROC uses edi ebx lpTHIS:DWORD, hSubMenu:DWORD, uItem:DWORD,
                                                            lpmi:DWORD

    LOCAL mii :MENUITEMINFOA

   SetObject edi, TMenu

    mov ebx, lpmi

     mov mii.cbSize, SIZEOF mii 
     
     mov mii.fMask, MIIM_FTYPE or MIIM_ID or MIIM_DATA or MIIM_SUBMENU
     mov mii.fType, MFT_OWNERDRAW
     m2m mii.wID, [ebx].MENUITEM.wID
     m2m mii.dwItemData, lpmi
     m2m mii.hSubMenu, hSubMenu
     
    invoke InsertMenuItem, [edi].hMenu, uItem, FALSE, ADDR mii
    push eax
    invoke DrawMenuBar, [edi].hWindow
    pop eax
    
   ReleaseObject edi
   ret
TMen_InsertMenuPopup_Funct  ENDP

; --=====================================================================================--
; #METHOD:      InsertSubMenuItem (:DWORD, :DWORD, :DWORD)
;
; #DESCRIPTION:         ..
;
; #PARAM:       hPopup    ,       ..
; #PARAM:       hSubMenu  ..
; #PARAM:       uItem            
;                        ..
; #PARAM:       lpmi       MENUITEM,     ..
;
; #RETURN:      TRUE -     ,     FALSE..
; --=====================================================================================--
TMen_InsertSubMenuItem_Funct  PROC uses edi ebx lpTHIS:DWORD, hPopup:DWORD, hSubMenu:DWORD,
                                                uItem:DWORD, lpmi:DWORD

    LOCAL mii :MENUITEMINFOA

   SetObject edi, TMenu

    mov ebx, lpmi

     mov mii.cbSize, SIZEOF mii
     mov mii.fMask, MIIM_FTYPE  or MIIM_DATA or MIIM_SUBMENU or MIIM_ID
     mov mii.fType, MFT_OWNERDRAW
     m2m mii.hSubMenu, hSubMenu
     m2m mii.dwItemData, lpmi
     m2m mii.wID, [ebx].MENUITEM.wID

    invoke InsertMenuItem, hPopup, uItem, hPopup, ADDR mii
    
   ReleaseObject edi
   ret
TMen_InsertSubMenuItem_Funct  ENDP

; --=====================================================================================--
; #METHOD:      InsertMenuItem (:DWORD, :DWORD, :DWORD)
;
; #DESCRIPTION:       ..
;
; #PARAM:       hPopup    ,       ..
; #PARAM:       uItem           
;                        ..
; #PARAM:       lpmi       MENUITEM,     ..
;
; #RETURN:      TRUE -     ,     FALSE..
; --=====================================================================================--
TMen_InsertMenuItem_Funct  PROC uses edi ebx lpTHIS:DWORD, hPopup:DWORD, uItem:DWORD, lpmi:DWORD

    LOCAL mii :MENUITEMINFOA

   SetObject edi, TMenu

    mov ebx, lpmi

     mov mii.cbSize, SIZEOF mii 
     
     mov mii.fMask, MIIM_FTYPE or MIIM_ID or MIIM_DATA
     mov mii.fType, MFT_OWNERDRAW
     m2m mii.wID, [ebx].MENUITEM.wID
     m2m mii.dwItemData, lpmi
     
    invoke InsertMenuItem, hPopup, uItem, FALSE, ADDR mii
    
   ReleaseObject edi
   ret
TMen_InsertMenuItem_Funct  ENDP

; --=====================================================================================--
; #METHOD:      CreateMenuPopup (VOID)
;
; #DESCRIPTION:   ..
;
; #PARAM:       NONE..
;
; #RETURN:        ,    FALSE..               
; --=====================================================================================--
TMen_CreateMenuPopup_Funct  PROC uses edi lpTHIS:DWORD
   SetObject edi, TMenu

    call CreatePopupMenu

   ReleaseObject edi
   ret
TMen_CreateMenuPopup_Funct  ENDP

; --=====================================================================================--
; METHOD:      DrawItem (:DWORD)
;
; DESCRIPTION:    WM_DRAWITEM..
;
; PARAM:       lParam      DRAWITEMSTRUCT..
;
; RETURN:      NONE..              
; --=====================================================================================--
TMen_DrawItem_Funct  PROC uses edi ebx lpTHIS:DWORD, lParam:DWORD

    LOCAL var    :DWORD
    
   SetObject edi, TMenu

mov ebx, lParam
assume ebx: ptr DRAWITEMSTRUCT

  .if [ebx].CtlType == ODT_MENU
  
    .if [ebx].itemAction == ODA_DRAWENTIRE  ;         

        .if [edi].StyleMenu == STYLE_XP     ;   XP
        
             METHOD edi, TMenu, OdaDrawentireXP, lParam
             
;       .elseif [edi].StyleMenu == STYLE_XX     ;   
             
;            METHOD edi, TMenu, OdaDrawentireXX, lParam ;              
             
        .endif

    .elseif [ebx].itemAction == ODA_SELECT  ;           

        .if [edi].StyleMenu == STYLE_XP
             METHOD edi, TMenu, OdaSelectXP, lParam
             
;       .elseif [edi].StyleMenu == STYLE_XX     ;   
             
;            METHOD edi, TMenu, OdaSelectXX, lParam ;              
             
        .endif
        
    .endif
        
  .endif

assume ebx: nothing     

   ReleaseObject edi
   ret
TMen_DrawItem_Funct  ENDP

; --=====================================================================================--
; METHOD:      MeasureItem (:DWORD)
;
; DESCRIPTION:    WM_MEASUREITEM..
;
; PARAM:       lParam      MEASUREITEMSTRUCT..
;
; RETURN:      NONE..
; --=====================================================================================--
TMen_MeasureItem_Funct  PROC uses edi ebx edx lpTHIS:DWORD, lParam:DWORD

    LOCAL mii   :MENUITEMINFO
    LOCAL mi    :MENUITEM
    LOCAL hDC   :HDC
    LOCAL StrSize :SIZEL

   SetObject edi, TMenu   

    mov ebx, lParam
    assume ebx: ptr MEASUREITEMSTRUCT

    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA or MIIM_TYPE
    invoke GetMenuItemInfo,[edi].hMenu,[ebx].itemID,FALSE,ADDR mii
    mov edx, mii.dwItemData
    
    m2m mi.hIcon, [edx].MENUITEM.hIcon
    m2m mi.lpString, [edx].MENUITEM.lpString 
    m2m mi.len, [edx].MENUITEM.len
    m2m mi.dwStyle, [edx].MENUITEM.dwStyle  
    
        .if [ebx].CtlType == ODT_MENU

            .if mi.dwStyle == MN_POPUP

                mov hDC, $invoke ( GetDC,[edi].hWindow ) 
                invoke GetTextExtentPoint32,hDC,mi.lpString,mi.len,ADDR StrSize
                invoke ReleaseDC,[edi].hWindow,hDC
                
                mov eax, StrSize.x
                sub eax, 8
                
                mov [ebx].itemWidth, eax
                mov [ebx].itemHeight, 22
            
            .elseif mi.dwStyle == MN_ITEM
            
                mov hDC, $invoke ( GetDC,[edi].hWindow ) 
                invoke GetTextExtentPoint32,hDC,mi.lpString,mi.len,ADDR StrSize
                invoke ReleaseDC,[edi].hWindow,hDC
                add StrSize.x, 22
                m2m [ebx].itemWidth, StrSize.x
                mov [ebx].itemHeight, 22
                
            .elseif mi.dwStyle == MN_SEPARATOR              
                                                    
                mov [ebx].itemHeight, 8
                
            .endif
            
        .endif

    assume ebx: nothing     

   ReleaseObject edi
   ret
TMen_MeasureItem_Funct  ENDP

; --=====================================================================================--
; METHOD:      OdaDrawentireXP (:DWORD)
;
; DESCRIPTION:   WM_DRAWITEM -> itemAction = ODA_DRAWENTIRE ( XP)..
;
; PARAM:       DrIt     DRAWITEMSTRUCT..
;
; RETURN:      NONE..
; --=====================================================================================--
TMen_OdaDrawentireXP_Funct  PROC uses edi ebx edx lpTHIS:DWORD, DrIt:DWORD

    LOCAL RctGray :RECT, RctFill :RECT, RctCheck :RECT
    LOCAL mii   :MENUITEMINFO
    LOCAL mi    :MENUITEM
    LOCAL p1    :POINT,p2   :POINT
    LOCAL OldFont:HFONT 

   SetObject edi, TMenu

mov ebx, DrIt
    
assume ebx: ptr DRAWITEMSTRUCT

    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA
    invoke GetMenuItemInfo,[edi].hMenu,[ebx].itemID,FALSE,ADDR mii
    mov edx, mii.dwItemData

    m2m mi.hIcon, [edx].MENUITEM.hIcon
    m2m mi.lpString, [edx].MENUITEM.lpString 
    m2m mi.len, [edx].MENUITEM.len
    m2m mi.dwStyle, [edx].MENUITEM.dwStyle
    
      .if mi.dwStyle == MN_POPUP

       mov eax, [ebx].itemState 
       and eax, ODS_HOTLIGHT
        
       .if eax          ; SELECT
       
          invoke SelectObject, [ebx].hdc, [edi].hPenBlue      
          invoke SelectObject, [ebx].hdc, [edi].hBrushBlue
          invoke RoundRect,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom,3,3
          invoke SetBkMode,[ebx].hdc,TRANSPARENT
          invoke DrawText, [ebx].hdc, mi.lpString, mi.len, ADDR [ebx].rcItem, DT_VCENTER + DT_SINGLELINE + DT_CENTER                
                    
       .else            ; UNSELECT
            
          invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_BTNFACE+1
          invoke SetBkMode,[ebx].hdc,TRANSPARENT
          invoke DrawText, [ebx].hdc, mi.lpString, mi.len, ADDR [ebx].rcItem, DT_VCENTER + DT_SINGLELINE + DT_CENTER
                                    
       .endif
       
     .elseif mi.dwStyle == MN_ITEM      ;     

       mov eax, [ebx].itemState 
       and eax, ODS_GRAYED

    .if eax 

       mov eax, [ebx].itemState 
       and eax, ODS_CHECKED
       
        .if eax

                invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                [ebx].rcItem.right,[ebx].rcItem.bottom
            
            ;   
                mov eax, [ebx].rcItem.left
                mov RctGray.left, eax
                mov eax, [ebx].rcItem.top 
                mov RctGray.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthGray        
                mov RctGray.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctGray.bottom, eax                         
                invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                
            .if mi.len  ; 
    
                METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,TXT_GRAY
                
            .endif
            
;                

                mov eax, [ebx].rcItem.left
                add eax, 2
                mov RctCheck.left, eax
                mov eax, [ebx].rcItem.top
                add eax, 2 
                mov RctCheck.top, eax
                mov eax, [ebx].rcItem.left
                add eax, 22       
                mov RctCheck.right, eax
                mov eax, [ebx].rcItem.bottom
                sub eax, 2
                mov RctCheck.bottom, eax
                invoke SelectObject, [ebx].hdc, [edi].hPenGray
                invoke SelectObject, [ebx].hdc, [edi].hBrushCheckDisabled
                invoke Rectangle,[ebx].hdc,RctCheck.left,RctCheck.top,
                                           RctCheck.right,RctCheck.bottom
                
                invoke SetBkMode,[ebx].hdc,TRANSPARENT
                mov OldFont, $invoke ( SelectObject, [ebx].hdc, [edi].hGlyphFont )                           
                invoke DrawText, [ebx].hdc,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER
                invoke SelectObject, [ebx].hdc, OldFont
        
        .else 
                
                invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
            
            ;   
                mov eax, [ebx].rcItem.left
                mov RctGray.left, eax
                mov eax, [ebx].rcItem.top 
                mov RctGray.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthGray        
                mov RctGray.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctGray.bottom, eax                         
                invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                
            .if mi.hIcon    ;    
        
                METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_GRAY
                
            .endif
            
            .if mi.len  ; 
    
                METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,TXT_GRAY
                
            .endif
            
        .endif

    .else

       mov eax, [ebx].itemState 
       and eax, ODS_CHECKED
       
        .if eax 

                invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
            
            ;   
                mov eax, [ebx].rcItem.left
                mov RctGray.left, eax
                mov eax, [ebx].rcItem.top 
                mov RctGray.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthGray        
                mov RctGray.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctGray.bottom, eax                         
                invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                
            .if mi.len  ; 
                
                METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                
            .endif

;                

                mov eax, [ebx].rcItem.left
                add eax, 2
                mov RctCheck.left, eax
                mov eax, [ebx].rcItem.top
                add eax, 2 
                mov RctCheck.top, eax
                mov eax, [ebx].rcItem.left
                add eax, 22       
                mov RctCheck.right, eax
                mov eax, [ebx].rcItem.bottom
                sub eax, 2
                mov RctCheck.bottom, eax
                invoke SelectObject, [ebx].hdc, [edi].hPenFrameCheck
                invoke SelectObject, [ebx].hdc, [edi].hBrushCheckUnSelect
                invoke Rectangle,[ebx].hdc,RctCheck.left,RctCheck.top,
                                           RctCheck.right,RctCheck.bottom
                
                invoke SetBkMode,[ebx].hdc,TRANSPARENT
                mov OldFont, $invoke ( SelectObject, [ebx].hdc, [edi].hGlyphFont )                           
                invoke DrawText, [ebx].hdc,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER
                invoke SelectObject, [ebx].hdc, OldFont
        .else

                invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
            
            ;   
                mov eax, [ebx].rcItem.left
                mov RctGray.left, eax
                mov eax, [ebx].rcItem.top 
                mov RctGray.top, eax
                mov eax, [ebx].rcItem.left
                add eax, WidthGray        
                mov RctGray.right, eax
                mov eax, [ebx].rcItem.bottom
                mov RctGray.bottom, eax                         
                invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                
            .if mi.hIcon    ;    
        
                METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_CENTER
                
            .endif
            
            .if mi.len  ; 
                
                METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                
            .endif          

        .endif

    .endif

    
     .elseif mi.dwStyle == MN_SEPARATOR     ;   SEPARATOR 

        invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
        invoke SelectObject, [ebx].hdc, [edi].hPenWhite
        invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
    
    ;   
        mov eax, [ebx].rcItem.left
        mov RctGray.left, eax
        mov eax, [ebx].rcItem.top 
        mov RctGray.top, eax
        mov eax, [ebx].rcItem.left
        add eax, WidthGray        
        mov RctGray.right, eax
        mov eax, [ebx].rcItem.bottom
        mov RctGray.bottom, eax                         
        invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
        
    ; LINE GRAY
        mov eax, RctGray.right
        add eax, 5
        mov p1.x, eax
        mov eax, [ebx].rcItem.bottom
        sub eax, [ebx].rcItem.top
        shr eax, 1
        mov ecx, eax
        mov eax, [ebx].rcItem.top
        add eax, ecx
        mov p1.y, eax
        mov p2.y, eax
        m2m p2.x, [ebx].rcItem.right

        invoke SelectObject, [ebx].hdc, [edi].hPenGray
        invoke MoveToEx,[ebx].hdc,p1.x,p1.y,0
        invoke LineTo,[ebx].hdc,p2.x,p2.y   
    
     .endif

    assume ebx: nothing

   ReleaseObject edi
   ret
TMen_OdaDrawentireXP_Funct  ENDP

; --=====================================================================================--
; METHOD:      OdaFocus (:DWORD)
;
; DESCRIPTION:   WM_DRAWITEM -> itemAction = ODA_FOCUS ( XP)..
;
; PARAM:       DrIt      DRAWITEMSTRUCT..
;
; RETURN:      NONE..
; --=====================================================================================--
TMen_OdaFocus_Funct  PROC uses edi lpTHIS:DWORD, DrIt:DWORD
   SetObject edi, TMenu   


   ReleaseObject edi
   ret
TMen_OdaFocus_Funct  ENDP

; --=====================================================================================--
; METHOD:      OdaSelectXP (:DWORD)
;
; DESCRIPTION:   WM_DRAWITEM -> itemAction = ODA_SELECT ( XP)..
;
; PARAM:       DrIt      DRAWITEMSTRUCT..
;
; RETURN:      NONE..
; --=====================================================================================--
TMen_OdaSelectXP_Funct  PROC uses edi ebx edx lpTHIS:DWORD, DrIt:DWORD

    LOCAL RctGray :RECT, RctFill :RECT, RctCheck :RECT
    LOCAL mii   :MENUITEMINFO
    LOCAL mi    :MENUITEM
    
   SetObject edi, TMenu   

mov ebx, DrIt
    
assume ebx: ptr DRAWITEMSTRUCT

    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_DATA
    invoke GetMenuItemInfo,[edi].hMenu,[ebx].itemID,FALSE,ADDR mii
    mov edx, mii.dwItemData

    m2m mi.hIcon, [edx].MENUITEM.hIcon
    m2m mi.lpString, [edx].MENUITEM.lpString 
    m2m mi.len, [edx].MENUITEM.len
    m2m mi.dwStyle, [edx].MENUITEM.dwStyle

     .if mi.dwStyle == MN_POPUP

       mov eax, [ebx].itemState 
       and eax, ODS_SELECTED

       .if eax          ; PRESSED - SELECT
          
;         PrintHex eax
          invoke SelectObject, [ebx].hdc, [edi].hBrushLightGray
          invoke RoundRect,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom,3,3
          invoke SetBkMode,[ebx].hdc,TRANSPARENT
          invoke DrawText, [ebx].hdc, mi.lpString, mi.len, ADDR [ebx].rcItem, DT_VCENTER + DT_SINGLELINE + DT_CENTER                
                    
       .else            ; UNSELECT
       
          invoke FillRect,[ebx].hdc,ADDR [ebx].rcItem,COLOR_BTNFACE+1
          invoke SetBkMode,[ebx].hdc,TRANSPARENT
          invoke DrawText, [ebx].hdc, mi.lpString, mi.len, ADDR [ebx].rcItem, DT_VCENTER + DT_SINGLELINE + DT_CENTER
                                    
       .endif
       
      .elseif mi.dwStyle == MN_ITEM

       mov eax, [ebx].itemState 
       and eax, ODS_SELECTED

       .if eax          ; PRESSED - SELECT

            mov eax, [ebx].itemState 
            and eax, ODS_GRAYED

            .if eax         
        
               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax     

                    .if mi.len  ; 
                    
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,TXT_GRAY
                        
                    .endif
                    
        ;                
        
                        mov eax, [ebx].rcItem.left
                        add eax, 2
                        mov RctCheck.left, eax
                        mov eax, [ebx].rcItem.top
                        add eax, 2 
                        mov RctCheck.top, eax
                        mov eax, [ebx].rcItem.left
                        add eax, 22       
                        mov RctCheck.right, eax
                        mov eax, [ebx].rcItem.bottom
                        sub eax, 2
                        mov RctCheck.bottom, eax
                        invoke SelectObject, [ebx].hdc, [edi].hPenGray
                        invoke SelectObject, [ebx].hdc, [edi].hBrushCheckDisabled
                        invoke Rectangle,[ebx].hdc,RctCheck.left,RctCheck.top,
                                                   RctCheck.right,RctCheck.bottom
                        
                        invoke SetBkMode,[ebx].hdc,TRANSPARENT
                        invoke SelectObject, [ebx].hdc, [edi].hGlyphFont                           
                        invoke DrawText, [ebx].hdc,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER                   
                
                .else
              
                    .if mi.hIcon    ;    
    
                        METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_GRAY
                        
                    .endif
                        
                    .if mi.len      ; 
                    
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,TXT_GRAY
                        
                    .endif
                
                .endif            
              
            .else

               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax

                    invoke SelectObject, [ebx].hdc, [edi].hPenBlue
                    invoke SelectObject, [ebx].hdc, [edi].hBrushBlue
                    invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                     [ebx].rcItem.right,[ebx].rcItem.bottom                 
            
                    .if mi.len  ; 
                        
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                        
                    .endif
                    
        ;                
        
                    mov eax, [ebx].rcItem.left
                    add eax, 2
                    mov RctCheck.left, eax
                    mov eax, [ebx].rcItem.top
                    add eax, 2 
                    mov RctCheck.top, eax
                    mov eax, [ebx].rcItem.left
                    add eax, 22       
                    mov RctCheck.right, eax
                    mov eax, [ebx].rcItem.bottom
                    sub eax, 2
                    mov RctCheck.bottom, eax
                    invoke SelectObject, [ebx].hdc, [edi].hPenFrameCheck
                    invoke SelectObject, [ebx].hdc, [edi].hBrushCheckSelect
                    invoke Rectangle,[ebx].hdc,RctCheck.left,RctCheck.top,
                                               RctCheck.right,RctCheck.bottom
                    
                    invoke SetBkMode,[ebx].hdc,TRANSPARENT
                    invoke SelectObject, [ebx].hdc, [edi].hGlyphFont                           
                    invoke DrawText, [ebx].hdc,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER               
                
                .else

                    invoke SelectObject, [ebx].hdc, [edi].hPenBlue
                    invoke SelectObject, [ebx].hdc, [edi].hBrushBlue
                    invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,
                                     [ebx].rcItem.right,[ebx].rcItem.bottom
                    
                    .if mi.hIcon    ;    
                
                        METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_LEFTUP
                        
                    .endif
                        
                    .if mi.len  ; 
                        
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                        
                    .endif                  
                
                .endif
        
            .endif      
        
       .else            ; UNSELECT

            mov eax, [ebx].itemState 
            and eax, ODS_GRAYED
            
            .if eax
 
                .if mi.hIcon    ;    
            
                    METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_GRAY
                    
                .endif
                
                .if mi.len  ; 

                    METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,TXT_GRAY
                    
                .endif              
            
            .else

               mov eax, [ebx].itemState 
               and eax, ODS_CHECKED
       
                .if eax
                
                        invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                        invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                        invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
                    
                    ;   
                        mov eax, [ebx].rcItem.left
                        mov RctGray.left, eax
                        mov eax, [ebx].rcItem.top 
                        mov RctGray.top, eax
                        mov eax, [ebx].rcItem.left
                        add eax, WidthGray        
                        mov RctGray.right, eax
                        mov eax, [ebx].rcItem.bottom
                        mov RctGray.bottom, eax                         
                        invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                    
                    .if mi.len  ; 
                        
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                        
                    .endif
                    
            ;                
            
                        mov eax, [ebx].rcItem.left
                        add eax, 2
                        mov RctCheck.left, eax
                        mov eax, [ebx].rcItem.top
                        add eax, 2 
                        mov RctCheck.top, eax
                        mov eax, [ebx].rcItem.left
                        add eax, 22       
                        mov RctCheck.right, eax
                        mov eax, [ebx].rcItem.bottom
                        sub eax, 2
                        mov RctCheck.bottom, eax
                        invoke SelectObject, [ebx].hdc, [edi].hPenFrameCheck
                        invoke SelectObject, [ebx].hdc, [edi].hBrushCheckUnSelect
                        invoke Rectangle,[ebx].hdc,RctCheck.left,RctCheck.top,
                                                   RctCheck.right,RctCheck.bottom
                        
                        invoke SetBkMode,[ebx].hdc,TRANSPARENT
                        invoke SelectObject, [ebx].hdc, [edi].hGlyphFont                           
                        invoke DrawText, [ebx].hdc,ADDR GlyphArray, 1, ADDR RctCheck, DT_CENTER or DT_VCENTER                   
                
                .else
                        invoke SelectObject, [ebx].hdc, [edi].hBrushWhite
                        invoke SelectObject, [ebx].hdc, [edi].hPenWhite
                        invoke Rectangle,[ebx].hdc,[ebx].rcItem.left,[ebx].rcItem.top,[ebx].rcItem.right,[ebx].rcItem.bottom
                    
                    ;   
                        mov eax, [ebx].rcItem.left
                        mov RctGray.left, eax
                        mov eax, [ebx].rcItem.top 
                        mov RctGray.top, eax
                        mov eax, [ebx].rcItem.left
                        add eax, WidthGray        
                        mov RctGray.right, eax
                        mov eax, [ebx].rcItem.bottom
                        mov RctGray.bottom, eax                         
                        invoke FillRect,[ebx].hdc,ADDR RctGray,[edi].hBrushGray
                    
                    .if mi.hIcon    ;    
                
                        METHOD edi, TMenu, DrawIcon, [ebx].hdc, ADDR [ebx].rcItem, mi.hIcon,IC_CENTER
                        
                    .endif
                    
                    .if mi.len      ; 
                        
                        METHOD edi, TMenu, DrawText, [ebx].hdc, ADDR [ebx].rcItem, mi.lpString,mi.len,0
                        
                    .endif                  
                
                .endif
    
            .endif      
                
       .endif
                  
      .endif

    assume ebx: nothing

   ReleaseObject edi
   ret
TMen_OdaSelectXP_Funct  ENDP

; --=====================================================================================--
; #METHOD:      SetItemGrayed (:DWORD, :DWORD, :DWORD)
;
; #DESCRIPTION:        ,  ..
;
; #PARAM:       hPopup       ..
; #PARAM:       uItem         ..
; #PARAM:       State    ,  :<br>
;                      ENABLED - ,<br>
;                      DISABLED - ..
;
; #RETURN:      TRUE -      ,<br>
;               FALSE -      ..
; --=====================================================================================--
TMen_SetItemGrayed_Funct  PROC uses edi ebx edx lpTHIS:DWORD, hPopup:DWORD, uItem:DWORD, State:DWORD

    LOCAL mii :MENUITEMINFO

   SetObject edi, TMenu

    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_STATE
    invoke GetMenuItemInfo, hPopup, uItem, FALSE, ADDR mii
    mov ebx, mii.fState
    push ebx    
    
    mov eax, State 
    and eax, ENABLED or DISABLED or REVERSE
 
    .if eax == ENABLED
 
      mov edx, MFS_GRAYED
      not edx
      and ebx, edx
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii 
 
     .elseif eax == DISABLED
    
      or ebx, MFS_GRAYED      
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii
      
     .elseif eax == REVERSE 

      xor ebx, MFS_GRAYED
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii 
      mov eax, edx
          
    .endif  

     pop eax
     
    and eax, MFS_GRAYED  
    .if eax 
        mov eax, TRUE
    .else
        xor eax, eax            
    .endif   
        
   ReleaseObject edi
   ret
TMen_SetItemGrayed_Funct  ENDP

; --=====================================================================================--
; #METHOD:      SetItemChecked (:DWORD, :DWORD, :DWORD)
;
; #DESCRIPTION:      ..
;
; #PARAM:       hPopup       ..
; #PARAM:       uItem          ..
; #PARAM:       State    ,  :
;               CHECKED -    ,<br>
;               UNCHECKED -   ,<br>
;               REVERSE -      ..
;
; #RETURN:      TRUE -       ,<br>
;               FALSE -        ..
; --=====================================================================================--
TMen_SetItemChecked_Funct  PROC uses edi ebx lpTHIS:DWORD, hPopup:DWORD, uItem:DWORD, State:DWORD

    LOCAL mii :MENUITEMINFO

   SetObject edi, TMenu

    mov mii.cbSize, SIZEOF mii
    mov mii.fMask, MIIM_STATE
    invoke GetMenuItemInfo, hPopup, uItem, FALSE, ADDR mii
    mov ebx, mii.fState
    push ebx
    
    mov eax, State 
    and eax, UNCHECKED or CHECKED or REVERSE
 
    .if eax == UNCHECKED

      and ebx, MFS_UNCHECKED
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii 
      mov eax, edx
        
     .elseif eax == CHECKED
    
      or ebx, MFS_CHECKED
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii 
      mov eax, edx
      
     .elseif eax == REVERSE
       
      xor ebx, MFS_CHECKED
      mov mii.fState, ebx 
      invoke SetMenuItemInfo,hPopup,uItem,FALSE, ADDR mii 
      mov eax, edx
         
    .endif
    
    pop eax
    and eax, MFS_CHECKED
    .if eax 
        mov eax, TRUE
    .else
        xor eax, eax            
    .endif      
    
   ReleaseObject edi
   ret
TMen_SetItemChecked_Funct  ENDP

; --=====================================================================================--
; #METHOD:      DeleteItemMenu (:DWORD)
;
; #DESCRIPTION:     ..
;
; #PARAM:       uItem        ..
;
; #RETURN:      TRUE -    ,<br>
;               FALSE -   ..
; --=====================================================================================--
TMen_DeleteItemMenu_Funct  PROC uses edi lpTHIS:DWORD, uItem:DWORD

    LOCAL mii :MENUITEMINFO

   SetObject edi, TMenu

    invoke DeleteMenu,[edi].hMenu,uItem,MF_BYCOMMAND
    push eax
    invoke DrawMenuBar, [edi].hWindow
    pop eax
    
   ReleaseObject edi
   ret
TMen_DeleteItemMenu_Funct  ENDP

; --=====================================================================================--
; METHOD:      DrawIcon (:DWORD, :DWORD, :DWORD, :DWORD)
;
; DESCRIPTION:     ..
;
; PARAM:       hDC           ..
; PARAM:       lpRect      RECT..
; PARAM:       HIcon        ..
; PARAM:       uFlags    ,  :<br>
;                        IC_CENTER -   ,<br>
;                        IC_LEFTUP -    + ..
;
; RETURN:      NONE..
; --=====================================================================================--
TMen_DrawIcon_Funct  PROC uses edi ebx lpTHIS:DWORD, hDC:HDC, lpRect:DWORD, HIcon:HICON, uFlags:DWORD

    LOCAL RctIcon :RECT
    LOCAL xX :DWORD, yY :DWORD
    LOCAL MonoIcon :DWORD
    LOCAL iconinfo :ICONINFO
    LOCAL hMemDC :DWORD        
    
   SetObject edi, TMenu

    mov ebx, lpRect
        
       mov eax, uFlags 
       and eax, IC_CENTER or IC_LEFTUP or IC_GRAY

    .if eax == IC_CENTER
    
        mov xX, 4
        mov yY, 4
        
    .elseif eax == IC_LEFTUP
    
        mov xX, 2
        mov yY, 2

    ;    ,           
        mov eax, [ebx].RECT.left
        add eax, 4
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, 4 
        mov RctIcon.top, eax

        mov hMemDC, $invoke (CreateCompatibleDC,hDC)
        invoke GetIconInfo,HIcon,ADDR iconinfo

        invoke SetTextColor,hDC,Black
        invoke SetBkColor,hDC,White     
        invoke SelectObject,hMemDC,iconinfo.hbmMask
        invoke SelectObject,hDC,[edi].hBrushShade
        invoke BitBlt,hDC,RctIcon.left, RctIcon.top,16, 16,hMemDC,0, 0,0B8074Ah ; D^(S&(P^D)))
        
        invoke DeleteObject,hMemDC
        
    .elseif eax == IC_GRAY                  

    ;           
        mov eax, [ebx].RECT.left
        add eax, 4
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, 4 
        mov RctIcon.top, eax

        mov hMemDC, $invoke (CreateCompatibleDC,hDC)
        invoke GetIconInfo,HIcon,ADDR iconinfo

        invoke SetTextColor,hDC,Black
        invoke SetBkColor,hDC,White     
        invoke SelectObject,hMemDC,iconinfo.hbmMask
        invoke SelectObject,hDC,[edi].hBrushShade
        invoke BitBlt,hDC,RctIcon.left, RctIcon.top,16, 16,hMemDC,0, 0,0B8074Ah ; D^(S&(P^D)))
        
        invoke DeleteObject,hMemDC

        jmp @f ;    
        
    .endif  

        mov eax, [ebx].RECT.left
        add eax, xX
        mov RctIcon.left, eax
        mov eax, [ebx].RECT.top
        add eax, yY 
        mov RctIcon.top, eax

        invoke DrawIconEx, hDC, RctIcon.left, RctIcon.top, HIcon,16, 16, NULL, NULL, DI_NORMAL

@@:
    
   ReleaseObject edi
   ret
TMen_DrawIcon_Funct  ENDP

; --=====================================================================================--
; METHOD:      DrawText (:DWORD, :DWORD, :DWORD, :DWORD, :DWORD)
;
; DESCRIPTION:     ..
;
; PARAM:       hDC              ..
; PARAM:       lpRect         RECT..
; PARAM:       lpString         ..
; PARAM:       nLength        ..
; PARAM:       uFlags       ,  :<br>
;                           TXT_GRAY -    ..
; RETURN:      NONE..
;
; --=====================================================================================--
TMen_DrawText_Funct  PROC uses edi ebx lpTHIS:DWORD, hDC:HDC, lpRect:DWORD, lpString:DWORD,
                                                     nLength:DWORD, uFlags:DWORD

    LOCAL RctText :RECT
    
   SetObject edi, TMenu
   
mov ebx, lpRect

     mov eax, uFlags 
     and eax, TXT_GRAY

    .if eax == TXT_GRAY
        RGB 120, 117, 112
        invoke SetTextColor,hDC,eax
    .endif

        mov eax, [ebx].RECT.left
        add eax, 28
        mov RctText.left, eax
        mov eax, [ebx].RECT.top
        mov RctText.top, eax
        mov eax, [ebx].RECT.right         
        mov RctText.right, eax
        mov eax, [ebx].RECT.bottom
        mov RctText.bottom, eax
        invoke SetBkMode,hDC,TRANSPARENT
        invoke DrawText, hDC, lpString, nLength, ADDR RctText, DT_VCENTER + DT_SINGLELINE       
    
   ReleaseObject edi
   ret
TMen_DrawText_Funct  ENDP

; --=====================================================================================--
; #METHOD:      SetMenuStyle (:DWORD)
;
; #DESCRIPTION:     ..
;
; #PARAM:       StyleMenu      ..
;
; #RETURN:        .. 
; --=====================================================================================--
TMen_SetMenuStyle_Funct  PROC uses edi lpTHIS:DWORD, StyleMenu :DWORD

   SetObject edi, TMenu
   
    mov eax, [edi].StyleMenu
    m2m [edi].StyleMenu, StyleMenu
    
   ReleaseObject edi
   ret
TMen_SetMenuStyle_Funct  ENDP

ENDIF